new;
library edf,pgraph;

S0 = 3.5;
K = 3.495;
sigma = 0.09;
r = 0.08;
rstar = 0.06;
tau = 60/365;

proc deltaGK(S0,K,sigma,tau,r,rstar);
  local w,d1,delta;

  w = sigma.*sqrt(tau);
  d1 = ( ln(S0./K) + (r-rstar).*tau )./w + 0.5*w;

  delta = exp(-rstar.*tau).*cdfn(d1);

  retp(delta);
endp;


proc FonctionAuxiliaire(S0);
  retp(callGK(S0,K,sigma,tau,r,rstar));
endp;

delta1 = deltaGK(S0,K,sigma,tau,r,rstar);
delta2 = gradp(&FonctionAuxiliaire,3.5);

output file = delta1.out reset;

print delta1;
print delta2;


output off;
