new;
library pgraph;

proc callGK(S0,K,sigma,tau,r,rstar);
  local w,d1,d2,C;

  w = sigma.*sqrt(tau);
  d1 = ( ln(S0./K) + (r-rstar).*tau )./w + 0.5*w;
  d2 = d1 - w;

  C = exp(-rstar.*tau).*S0.*cdfn(d1) - k.*exp(-r.*tau).*cdfn(d2);
  retp(C);
endp;


S0 = 3.5;
tau = 60/365;
r = 0.08;
rstar = 0.06;
sigma = 0.09;

output file = gk4.out reset;

print callGK(3.51,S0,sigma,tau,r,rstar);

output off;

PrixExercice = seqa(3.45,0.01,101);
Prime = callGK(S0,PrixExercice,sigma,tau,r,rstar);

graphset;
  _pnum = 2; _pdate = "";
  xlabel("Prix d'exercice");
  ylabel("Prime de l'option d'achat");
  graphprt("-c=1 -cf=gk4.eps");
  xy(PrixExercice,Prime);


