new;
library edf,tsm,optmum,pgraph;

S0 = 3.5; K = 3.51; sigma = 0.19; tau = 90/365;
r = 0.08; rstar = 0.075;
Narbitrage = 4;

deltaTau = -4/365;  /* 4 jours */
deltaT = -deltaTau;

proc muProc(t,S);
  retp( (r-rstar)*S );
endp;

proc sigmaProc(t,S);
  retp( sigma*S );
endp;

/* t0 */

{C,arbreC} = OptionAmericaine(S0,K,sigma,tau,r,rstar,Narbitrage);
{Clb,Plb} = LookBackOption(S0,sigma,tau,r,rstar,Narbitrage);

Portefeuille0 = 10*C + 3*Plb - 5*Clb;


/* t1 */

Ns = 1000;
{t,S} = EulerMaruyama(S0,&muProc,&sigmaProc,0,deltaT,10,Ns);

S1 = S[10,.]';
C1 = zeros(Ns,1);
Clb1 = zeros(Ns,1);
Plb1 = zeros(Ns,1);
i = 1;
do until i > Ns;
  {C1[i],arbreC} = OptionAmericaine(S1[i],K,sigma,tau+deltaTau,r,rstar,Narbitrage);
  {Clb1[i],Plb1[i]} = LookBackOption(S1[i],sigma,tau+deltaTau,r,rstar,Narbitrage);
  i = i + 1;
endo;

Portefeuille1 = 10*C1 + 3*Plb1 - 5*Clb1;

deltaPortefeuille = Portefeuille1 - Portefeuille0;

{absc,dens,repart,retcode} = Kernel(deltaPortefeuille);

graphset;
  _pdate = ""; _pnum = 2;
  title("Fonction de densite de la variation du portefeuille");
  graphprt("-c=1 -cf=var9.eps"); 
  xy(absc,dens);
